function matrix = arr2mat(X) 
# usage: matrix = arr2mat(X) 
#
# This function converts a multidimensional array of dimension two or 
# less to its normal matrix form.

# Author:  Ronald Kumon

  # Error checking
  if ( nargin != 1 )
    usage("arr2mat(X)");
  endif

  if ( is_struct(X) != 1 )
    error("Input argument is not a multidimensional array.")
  end

  Xndim=X.ndim;
  Xdims=X.dims;

  if ( Xndim > 2 )
    error("The multidimensional array must have dimension of two or less to convert to a normal matrix.")
  elseif ( Xndim == 2 )
    matrix=zeros(Xdims(1),Xdims(2));
    for index1=1:Xdims(1)
      for index2=1:Xdims(2)
        arrindex=arrcoord2index([index1 index2],Xdims);
        matrix(index1,index2)=X.elems(arrindex);
      end
    end
  elseif ( Xndim == 1 )
    matrix=X.elems;
  else
    matrix=X.elems;
  end

endfunction

