function Z = arradd(X,Y) 
# usage: Z = arradd(X,Y)  
#
# This function adds two multidimensional arrays "X" and "Y" and puts 
# the result into a new multidimensional array "Z".  The arrays may 
# only be added if they have the same number of dimensions and same 
# index structure.

# Author:  Ronald Kumon

  # Error checking
  if ( nargin != 2 )
    usage("arradd(X,Y)");
  endif

  if ( ( is_struct(X) != 1 ) || ( is_struct(Y) != 1 ) )
    error("Input arguments are not multidimensional array structures.");
  end

  if ( X.ndim != Y.ndim) 
    error("Number of dimensions does not match.")
  elseif ( prod(X.dims==Y.dims) != 1 )
    error("Number of indices does not match number of dimensions.")
  end

  # Compute sum
  Z.ndim=X.ndim;
  Z.dims=X.dims;
  Z.elems=X.elems+Y.elems;

endfunction

