function arrdisplay(X)
# usage: arrdisplay(X)  
#
# This function diplays a multidimensional array by breaking it up
# into a sets of matrices of the form X(:,:,i_1,i_2,...,i_n-2), where
# X is an n-dimensional array.

# Uses:  arr2mat.m, arrindexorder.m, 

# Author:  Ronald Kumon

  # Error checking
  if ( nargin < 1 )
    usage("arrsubarr(X,...)");
  endif

  if ( is_struct(X) != 1 )
    error("Input argument is not a multidimensional array structure.")
  end

  Xndim=X.ndim;
  Xdims=X.dims;

  print_answer_id_name=0;
  if ( Xndim == 0 )
    printf("Type: Scalar\n");
    printf("Scalar = \n");
    X.elems   
  elseif ( Xndim == 1 )
    printf("Type: %i X 1 Vector\n",Xdims(1));
    printf("Vector = \n");
    X.elems    
  elseif ( Xndim == 2 )
    printf("Type: %i X %i Matrix\n",Xdims(1),Xdims(2));
    printf("Matrix = \n");
    arr2mat(X) 
  else
    Xextrandim=Xndim-2;
    Xextradims=Xdims(3:Xndim);   
    Xextracoord=arrindexorder(Xextradims);
    printf("Type: ");
    for index=1:(Xndim-1)
      printf("%i X ",Xdims(index));
    end
    printf("%i Array \n",Xdims(Xndim));
    for index=1:prod(Xextradims)
       empty_list_elements_ok=1;
       string="";
       if ( Xextrandim == 1 )
         string=sprintf("%i)",Xextracoord(index));
       else
         for index2=1:(Xextrandim-1)
           strpart=sprintf("%i,",Xextracoord(index,index2));
           string=[string,strpart];
         end
         strpart=sprintf("%i)",Xextracoord(index,Xextrandim));
         string=[string,strpart];
       end
       empty_list_elements_ok=0;
       printf(["Array(:,:,",string," = \n"]);
       eval(["arr2mat(arrsubarr(X,:,:,",string,")"]);
    end
  end
  print_answer_id_name=1;

endfunction

