function X=arrelemassg(X,coord,x) 
# usage: X=arrelemassg(X,coord,x)  
#
# This function assigns the value of "x" to the multidimensional array "X" 
# at the location given by a multidimensional vector of indices "coord".
#
# Uses:  arrcoord2index.m

# Author:  Ronald Kumon

  # Error checking
  if ( nargin != 3 )
    usage("arrelemassg(X,coord,x)");
  endif

  if ( is_struct(X) != 1 )
    error("Input argument is not a multidimensional array structure.")
  end

  if ( is_vector(coord) != 1 )
    error("Specified coordinates are not in vector form.")
  end

  if ( is_scalar(x) != 1 )
    error("Specified element is not a scalar.")
  end

  d = X.ndim; 
  k = X.dims; 

  if ( d == 0 )
    X.elems=x;
  else
    if ( length(coord) != d )
      error("Number of specified indices does not equal number of dimensions.")
    end
    for r=1:length(k)
      if ( ( coord(r) < 1    )      || \ 
           ( coord(r) > k(r) )      || \ 
           ( rem(coord(r),1) != 0 ) )
        error("Specified indices are out of bounds.")
      end 
    end
    # Compute array index from coordinates
    arrindex=arrcoord2index(coord,k);
    # Assign element to structure
    X.elems(arrindex)=x;
  end


endfunction

