function [coord,count]=arrforloops(n,loops,startvector,stepvector,coord,count)
# usage: [coord,count]=arrforloops(n,loops,startvector,stepvector,coord,count)
#
#This recursive function allows an arbitrary number of nested for loops
#to be generated for purposes of generating the coordinate indices of 
#subarrays.  The nesting structure of the loops is specified by 
#the vector "loops".  For example, loops=[4 3 2] specifies
#   for index1=1:2
#     for index2=1:3
#       for index3=1:2
#         ....
#       end
#     end
#   end
# The vector "startvector" is the beginning set of coordinate indices
# which will be added to in each iteration by the elements of "stepvector".  
# To see how this works, uncomment the printf commands and remove 
# the semicolons from the startvector lines.  You will then be able 
# to see how the coordinates are generated.  The coordinate indices 
# are filled from right to left (change "svl-n" to "n" for left to right).

# Author:  Ronald Kumon

svl=length(startvector)+1;

if ( n > 1)
  for index=1:loops(n)
    #printf("n=%g\n",n);
    startvector(svl-n)=startvector(svl-n)+stepvector(svl-n);
    [coord,count]=arrforloops(n-1,loops,startvector,stepvector,coord,count);
  end
else
  for index=1:loops(n)
    #printf("n=%g\n",n);
    stepvector(n);
    startvector(svl-n)=startvector(svl-n)+stepvector(svl-n);
    coord(count,:)=startvector;
    count=count+1;
  end
end

endfunction

