function X = arrlevicivita3 
# usage: X = arrlevicivita3  
#
# This function defines the three dimensional array of the 
# Levi-Civita symbol (1 if the indices=123, 231, 312, 
# -1 if the indices=132, 213, 321, 0 otherwise).
#
# Uses: arrindexorder.m

# Author:  Ronald Kumon

  # Error checking
  if ( nargin != 0 )
    usage("arrlevicivita3");
  endif

  X.ndim=3;
  X.dims=[3 3 3].';

  Xcoord=arrindexorder(X.dims);
  
  for index=1:prod(X.dims)
    coord=Xcoord(index,:)
    if ( coord(1)==1 && coord(2)==2 && coord(3)==3 )
      X.elems(index)=1
    elseif ( coord(1)==2 && coord(2)==3 && coord(3)==1 )
      X.elems(index)=1
    elseif ( coord(1)==3 && coord(2)==1 && coord(3)==2 )
      X.elems(index)=1
    elseif ( coord(1)==1 && coord(2)==3 && coord(3)==2 )
      X.elems(index)=-1
    elseif ( coord(1)==2 && coord(2)==1 && coord(3)==3 )
      X.elems(index)=-1
    elseif ( coord(1)==3 && coord(2)==2 && coord(3)==1 )
      X.elems(index)=-1
    else
      X.elems(index)=0
    end
  end

endfunction

