function Z = arrscalmult(a,X) 
# usage: Z = arrscalmult(a,X)
#
# This function multiplies an multidimensional array "X" by a scalar "a" 
# and puts the result into a new multidimensional array "Z".  

# Author:  Ronald Kumon

  # Error checking
  if ( nargin != 2 )
    usage("arrscalmult(a,X)");
  endif

  if ( is_scalar(a) != 1 )
    error("Specified factor is not a scalar.")
  end

  if ( is_struct(X) != 1 )
    error("Input argument is not a multidimensional array structure.")
  end

  Z.ndim=X.ndim;
  Z.dims=X.dims;
  Z.elems=a*X.elems;

endfunction

