function k = arrsize(X) 
# usage: k = arrsize(X)  
#
# This function extracts a column vector from a structure "X" which contains 
# the index structure of the multidimensional array contained in X.  

# Author:  Ronald Kumon

  # Error checking
  if ( nargin != 1 )
    usage("arrsize(X)");
  endif

  if ( is_struct(X) != 1 )
    error("Input argument is not a multidimensional array structure.")
  end

  # Extract array index ranges from structure
  k=X.dims;

endfunction

