function vec = arrval(X) 
# vec = arrval(X)  
#
# This function extracts a column vector from a structure "X" which contains 
# the multidimensional array contained in X.  

# Author:  Ronald Kumon

  # Error checking
  if ( nargin != 1 )
    usage("arrval(X)");
  endif

  if ( is_struct(X) != 1 )
    error("Input argument is not a multidimensional array structure.")
  end

  # Extract vector of array elements from structure
  vec=X.elems;

endfunction

