function x = arrvoigtmapinv(y) 
# usage: x = arrvoigtmapinv(y) 
#
# This function maps a single index "y" to a pair of indices "x" 
# according to the Voigt convention:
#   1 -> (11), 2 -> (22), 3 -> (33)
#   4 -> (23), 5 -> (23), 6 -> (12)

# Author:  Ronald Kumon

  # Error checking
  if ( nargin != 1 )
    usage("arrvoigtmapinv(y)");
  endif

  if ( is_scalar(y) != 1 ) 
    error("The input argument must be in scalar form.");
  end

  if ( (y < 1) || (y > 6) )
    error("The values of the input index must be between 1 and 6.");
  end

  if ( y <= 3 )
    x=[y y];
  elseif ( y == 4 )
    x=[2 3];
  elseif ( y == 5 )
    x=[1 3];
  else
    x=[1 2];
  end

endfunction

