# Define strain 
epsvec=[11 12 13 12 22 23 13 23 33];
epsilon=arrassg(2,[3 3],epsvec);
epsilonmat=arr2mat(epsilon);

# Define second order elastic constants
#cvoigtvec=[11 12 13 14 15 16 \
#           12 22 23 24 25 26 \
#           13 23 33 34 35 36 \
#           14 24 34 44 45 46 \
#           15 25 35 45 55 56 \
#           16 26 36 46 56 66 ];
cvoigtvec=[1111 1122 1133 1123 1113 1112 \
           1122 2222 2233 2223 2213 2212 \
           1133 2233 3333 3323 3313 3312 \
           1123 2223 3323 2323 2313 2312 \
           1113 2213 3313 2313 1313 1312 \
           1112 2212 3312 2312 1312 1212 ];
cvoigt=arrassg(2,[6 6],cvoigtvec);
cvoigtmat=arr2mat(cvoigt);
c=arrvoigt2reg(cvoigt);

# Checking symmetry properties of cvoigt and c
# Should all equal 1
#arrcompare(cvoigt,arrindexperm(cvoigt,[2 1]))
#arrcompare(c,arrindexperm(c,[1 2 4 3])) 
#arrcompare(c,arrindexperm(c,[2 1 3 4]))
#arrcompare(c,arrindexperm(c,[2 1 4 3]))
#arrcompare(c,arrindexperm(c,[3 4 1 2]))
#arrcompare(c,arrindexperm(c,[4 3 1 2]))
#arrcompare(c,arrindexperm(c,[4 3 2 1]))

# Compute stress using full indices
tau=arrcontr(c,[3 4],epsilon,[1 2],[1 2]);
tauconvertvoigt=arrreg2voigt(tau);

# Compute stress using abbrieviated indices
epsilonvoigt=arrreg2voigttwo(epsilon);
epsilonvoigtmat=arr2mat(epsilonvoigt);
tauvoigt=arrcontr(cvoigt,2,epsilonvoigt,1);
tauvoigtconvert=arrvoigt2reg(tauvoigt);

# Compare results
#[eq,eqtype,eqinfo]=arrcompare(tau,tauvoigtconvert)
#[eq2,eqtype2,eqinfo2]=arrcompare(tauvoigt,tauconvertvoigt)
#arrdisplay(tau)
#arrdisplay(tauvoigtconvert)

svoigt=inv(arr2mat(cvoigt))
