function retval = is_tensor(X) 
# usage: retval = is_tensor(X)   
#
# This function takes the multidimensional array "X", 
# and tests it to see if it is a tensor (the range of all 
# indices is equal).  The function returns 1 if the 
# array is a tensor.

# Author:  Ronald Kumon

  # Error checking
  if ( nargin != 1 )
    usage("is_tensor(X)");
  endif

  if ( is_struct(X) != 1 )
    error("Input argument is not a multidimensional array structure.")
  end

  ndim=X.ndim;
  dims=X.dims;

  if ( ndim==1 )
    retval= (dims==1);
  else
    retval= all((dims-dims(1)) == zeros(length(dims),1));  
  end

endfunction

