# testdefmat.m
# usage: testdefmat.m
#
# This function generates a bunch of multidimensional arrays
# for testing purposes.  They are defined such that the value of 
# each element is the same as the index value in decimal form
# e.g., c3_{1,2,3}=123
#
# Here the letters represent the the dimension of the array
# and the number represents the number of indices in each dimension.
# For example, c4 is a three ("c" is third letter of alphabet) dimension
# of a 4 X 4 X 4 array.  Arrays with different numbers of indices in 
# each dimension are given by arrays starting with "mix" and then
# the array structure.
#
# Uses:  arrindexorderdec.m

# Author:  Ronald Kumon

a1.ndim=0;
a1.dims=1;
a1.elems=1;
a1mat=1;

b1.ndim=0;
b1.dims=1;
b1.elems=2;
b1mat=1;

c1.ndim=0;
c1.dims=1;
c1.elems=3;

d1.ndim=0;
d1.dims=1;
d1.elems=4;

a2.ndim=1;
a2.dims=[2];
a2.elems=arrindexorderdec(a2.dims);
a2mat=[1; 2];

b2.ndim=2;
b2.dims=[2; 2];
b2.elems=arrindexorderdec(b2.dims);
b2mat=[11 12; 21 22];

c2.ndim=3;
c2.dims=[2; 2; 2];
c2.elems=arrindexorderdec(c2.dims);

d2.ndim=4;
d2.dims=[2; 2; 2; 2];
d2.elems=arrindexorderdec(d2.dims);

a3.ndim=1;
a3.dims=[3];
a3.elems=arrindexorderdec(a3.dims);
a3mat=[1; 2; 3];

b3.ndim=2;
b3.dims=[3; 3];
b3.elems=arrindexorderdec(b3.dims);
b3mat=[11 12 13; 21 22 23; 31 32 33];

c3.ndim=3;
c3.dims=[3; 3; 3];
c3.elems=arrindexorderdec(c3.dims);

d3.ndim=4;
d3.dims=[3; 3; 3; 3];
d3.elems=arrindexorderdec(d3.dims);

a4.ndim=1;
a4.dims=[4];
a4.elems=arrindexorderdec(a4.dims);

b4.ndim=2;
b4.dims=[4; 4];
b4.elems=arrindexorderdec(b4.dims);

c4.ndim=3;
c4.dims=[4; 4; 4];
c4.elems=arrindexorderdec(c4.dims);

d4.ndim=4;
d4.dims=[4; 4; 4; 4];
d4.elems=arrindexorderdec(d4.dims);

mix23.ndim=2;
mix23.dims=[2; 3];
mix23.elems=arrindexorderdec(mix23.dims);

mix43.ndim=2;
mix43.dims=[4; 3];
mix43.elems=arrindexorderdec(mix43.dims);

mix35.ndim=2;
mix35.dims=[3; 5];
mix35.elems=arrindexorderdec(mix35.dims);

mix234.ndim=3;
mix234.dims=[2; 3; 4];
mix234.elems=arrindexorderdec(mix234.dims);

mix235.ndim=3;
mix235.dims=[2; 3; 5];
mix235.elems=arrindexorderdec(mix235.dims);

voigt1.ndim=1;
voigt1.dims=[6];
voigt1.elems=arrindexorderdec(voigt1.dims);

voigt2.ndim=2;
voigt2.dims=[6; 6];
voigt2.elems=arrindexorderdec(voigt2.dims);

voigt3.ndim=3;
voigt3.dims=[6; 6; 6];
voigt3.elems=arrindexorderdec(voigt3.dims);

#reg1=arrvoigt2arr(voigt1);
#reg2=arrvoigt2arr(voigt2);
#reg3=arrvoigt2arr(voigt3);
